Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 541)
@@ -2077,5 +2077,5 @@
     /* Optionally registers WAV file */
     if (app_config.wav_file.slen) {
-	status = pjsua_player_create(&app_config.wav_file, 0, NULL,
+	status = pjsua_player_create(&app_config.wav_file, 0, 
 				     &app_config.wav_id);
 	if (status != PJ_SUCCESS)
Index: pjproject/trunk/pjsip-apps/src/samples/confsample.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/confsample.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/confsample.c	(revision 541)
@@ -200,5 +200,5 @@
 					      clock_rate, channel_count,
 					      samples_per_frame, 
-					      bits_per_sample, 0, 0, NULL,
+					      bits_per_sample, 0, 0, 
 					      &rec_port);
     if (status != PJ_SUCCESS) {
@@ -223,5 +223,4 @@
 			0,		    /* flags	    */
 			0,		    /* buf size	    */
-			NULL,		    /* user data    */
 			&file_port[i]	    /* result	    */
 			);
Index: pjproject/trunk/pjsip-apps/src/samples/debug.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/debug.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/debug.c	(revision 541)
@@ -28,4 +28,4 @@
  *  #include "playfile.c"
  */
-#include "sndtest.c"
+#include "siprtp.c"
 
Index: pjproject/trunk/pjsip-apps/src/samples/level.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/level.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/level.c	(revision 541)
@@ -117,5 +117,4 @@
 					      0,	/* flags	    */
 					      0,	/* default buffer   */
-					      NULL,	/* user data	    */
 					      &file_port/* returned port    */
 					      );
Index: pjproject/trunk/pjsip-apps/src/samples/playfile.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/playfile.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/playfile.c	(revision 541)
@@ -128,5 +128,4 @@
 					      0,	/* flags	    */
 					      0,	/* default buffer   */
-					      NULL,	/* user data	    */
 					      &file_port/* returned port    */
 					      );
Index: pjproject/trunk/pjsip-apps/src/samples/recfile.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/recfile.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/recfile.c	(revision 541)
@@ -123,5 +123,5 @@
 					      SAMPLES_PER_FRAME,
 					      BITS_PER_SAMPLE,
-					      0, 0, NULL,
+					      0, 0, 
 					      &file_port);
     if (status != PJ_SUCCESS) {
Index: pjproject/trunk/pjsip-apps/src/samples/resampleplay.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/resampleplay.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/resampleplay.c	(revision 541)
@@ -122,5 +122,5 @@
     /* Create the file port. */
     status = pjmedia_wav_player_port_create( pool, argv[pj_optind], 0, 0,
-					     0, 0, &file_port);
+					     0, &file_port);
     if (status != PJ_SUCCESS) {
 	app_perror(THIS_FILE, "Unable to open file", status);
Index: pjproject/trunk/pjsip-apps/src/samples/streamutil.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/streamutil.c	(revision 540)
+++ pjproject/trunk/pjsip-apps/src/samples/streamutil.c	(revision 541)
@@ -375,5 +375,5 @@
 		    stream_port->info.clock_rate;
 	status = pjmedia_wav_player_port_create(pool, play_file, wav_ptime,
-						0, -1, NULL, &play_file_port);
+						0, -1, &play_file_port);
 	if (status != PJ_SUCCESS) {
 	    app_perror(THIS_FILE, "Unable to use file", status);
Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 540)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 541)
@@ -2236,5 +2236,4 @@
  *			clock rate is supported).
  * @param options	Options (currently zero).
- * @param user_data	Arbitrary user data to be associated with the player.
  * @param p_id		Pointer to receive player ID.
  *
@@ -2243,5 +2242,4 @@
 PJ_DECL(pj_status_t) pjsua_player_create(const pj_str_t *filename,
 					 unsigned options,
-					 void *user_data,
 					 pjsua_player_id *p_id);
 
@@ -2298,6 +2296,4 @@
  *			limitation.
  * @param options	Optional options.
- * @param user_data	Arbitrary user data which will be given in the 
- *			callback once the recording complete.
  * @param p_id		Pointer to receive the recorder instance.
  *
@@ -2309,5 +2305,4 @@
 					   pj_ssize_t max_size,
 					   unsigned options,
-					   void *user_data,
 					   pjsua_recorder_id *p_id);
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 540)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 541)
@@ -601,5 +601,4 @@
 PJ_DEF(pj_status_t) pjsua_player_create( const pj_str_t *filename,
 					 unsigned options,
-					 void *user_data,
 					 pjsua_player_id *p_id)
 {
@@ -631,5 +630,5 @@
 					    pjsua_var.mconf_cfg.samples_per_frame *
 					      1000 / pjsua_var.media_cfg.clock_rate, 
-					    0, 0, user_data, &port);
+					    0, 0, &port);
     if (status != PJ_SUCCESS) {
 	PJSUA_UNLOCK();
@@ -722,5 +721,4 @@
 					   pj_ssize_t max_size,
 					   unsigned options,
-					   void *user_data,
 					   pjsua_recorder_id *p_id)
 {
@@ -754,5 +752,5 @@
 					    pjsua_var.mconf_cfg.samples_per_frame,
 					    pjsua_var.mconf_cfg.bits_per_sample, 
-					    0, 0, user_data, &port);
+					    0, 0, &port);
     if (status != PJ_SUCCESS) {
 	PJSUA_UNLOCK();