Index: /pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- /pjproject/trunk/pjmedia/build/Makefile	(revision 557)
+++ /pjproject/trunk/pjmedia/build/Makefile	(revision 558)
@@ -66,10 +66,10 @@
 export PJMEDIA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
 			clock_thread.o codec.o conference.o endpoint.o errno.o \
-			wav_player.o wav_writer.o g711.o jbuf.o \
-			master_port.o null_port.o plc_common.o plc_g711.o \
+			g711.o jbuf.o master_port.o mem_capture.o mem_player.o \
+			null_port.o plc_common.o plc_g711.o \
 			port.o resample.o \
 			resample_port.o rtcp.o rtp.o sdp.o sdp_cmp.o sdp_neg.o \
 			session.o silencedet.o sound_port.o stream.o \
-			transport_udp.o wave.o \
+			transport_udp.o wav_player.o wav_writer.o wave.o \
 			$(SOUND_OBJS) $(NULLSOUND_OBJS)
 
Index: /pjproject/trunk/pjmedia/include/pjmedia.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia.h	(revision 557)
+++ /pjproject/trunk/pjmedia/include/pjmedia.h	(revision 558)
@@ -34,4 +34,5 @@
 #include <pjmedia/jbuf.h>
 #include <pjmedia/master_port.h>
+#include <pjmedia/mem_port.h>
 #include <pjmedia/null_port.h>
 #include <pjmedia/plc.h>
@@ -42,10 +43,11 @@
 #include <pjmedia/sdp.h>
 #include <pjmedia/sdp_neg.h>
+#include <pjmedia/session.h>
 #include <pjmedia/silencedet.h>
-#include <pjmedia/session.h>
+#include <pjmedia/sound.h>
+#include <pjmedia/sound_port.h>
+#include <pjmedia/splitcomb.h>
 #include <pjmedia/transport.h>
 #include <pjmedia/transport_udp.h>
-#include <pjmedia/sound.h>
-#include <pjmedia/sound_port.h>
 #include <pjmedia/wav_port.h>
 #include <pjmedia/wave.h>
Index: /pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 557)
+++ /pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 558)
@@ -52,8 +52,8 @@
     pj_sockaddr_in	rem_rtp_addr;	/**< Remote RTP address		    */
     pj_sockaddr_in	rem_rtcp_addr;	/**< Remote RTCP address	    */
-    void  (*rtp_cb)(	pjmedia_stream*,/**< To report incoming RTP.	    */
+    void  (*rtp_cb)(	void*,		/**< To report incoming RTP.	    */
 			const void*,
 			pj_ssize_t);
-    void  (*rtcp_cb)(	pjmedia_stream*,/**< To report incoming RTCP.	    */
+    void  (*rtcp_cb)(	void*,		/**< To report incoming RTCP.	    */
 			const void*,
 			pj_ssize_t);
@@ -322,5 +322,5 @@
     PJ_ASSERT_RETURN(tp, PJ_EINVAL);
 
-    /* Must not close while stream is using this */
+    /* Must not close while application is using this */
     PJ_ASSERT_RETURN(!udp->attached, PJ_EINVALIDOP);
     
@@ -449,5 +449,5 @@
 
 
-/* Called by stream to initialize the transport */
+/* Called by application to initialize the transport */
 static pj_status_t transport_attach(   pjmedia_transport *tp,
 				       void *user_data,
@@ -466,8 +466,8 @@
     PJ_ASSERT_RETURN(tp && rem_addr && addr_len, PJ_EINVAL);
 
-    /* Must not be "attached" to existing stream */
+    /* Must not be "attached" to existing application */
     PJ_ASSERT_RETURN(!udp->attached, PJ_EINVALIDOP);
 
-    /* "Attach" the stream: */
+    /* "Attach" the application: */
 
     /* Copy remote RTP address */
@@ -491,5 +491,5 @@
 
 
-/* Called by stream when it no longer needs the transport */
+/* Called by application when it no longer needs the transport */
 static void transport_detach( pjmedia_transport *tp,
 			      void *user_data)
@@ -505,8 +505,8 @@
     pj_assert(user_data == udp->user_data);
 
-    /* First, mark stream as unattached */
+    /* First, mark transport as unattached */
     udp->attached = PJ_FALSE;
 
-    /* Clear up stream infos from transport */
+    /* Clear up application infos from transport */
     udp->rtp_cb = NULL;
     udp->rtcp_cb = NULL;
@@ -515,5 +515,5 @@
 
 
-/* Called by stream to send RTP packet */
+/* Called by application to send RTP packet */
 static pj_status_t transport_send_rtp( pjmedia_transport *tp,
 				       const void *pkt,
@@ -557,5 +557,5 @@
 }
 
-/* Called by stream to send RTCP packet */
+/* Called by application to send RTCP packet */
 static pj_status_t transport_send_rtcp(pjmedia_transport *tp,
 				       const void *pkt,