Index: /pjproject/trunk/pjsip-apps/src/samples/siprtp_report.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/siprtp_report.c	(revision 564)
+++ /pjproject/trunk/pjsip-apps/src/samples/siprtp_report.c	(revision 565)
@@ -160,9 +160,9 @@
 	   "",
 	   audio->rtcp.stat.rx.loss,
-	   audio->rtcp.stat.rx.loss * 100.0 / audio->rtcp.stat.rx.pkt,
+	   audio->rtcp.stat.rx.loss * 100.0 / (audio->rtcp.stat.rx.pkt + audio->rtcp.stat.rx.loss),
 	   audio->rtcp.stat.rx.dup, 
-	   audio->rtcp.stat.rx.dup * 100.0 / audio->rtcp.stat.rx.pkt,
+	   audio->rtcp.stat.rx.dup * 100.0 / (audio->rtcp.stat.rx.pkt + audio->rtcp.stat.rx.dup),
 	   audio->rtcp.stat.rx.reorder, 
-	   audio->rtcp.stat.rx.reorder * 100.0 / audio->rtcp.stat.rx.pkt,
+	   audio->rtcp.stat.rx.reorder * 100.0 / (audio->rtcp.stat.rx.pkt + audio->rtcp.stat.rx.reorder),
 	   "",
 	   audio->rtcp.stat.rx.loss_period.min / 1000.0, 
@@ -203,9 +203,9 @@
 	   "",
 	   audio->rtcp.stat.tx.loss,
-	   audio->rtcp.stat.tx.loss * 100.0 / audio->rtcp.stat.tx.pkt,
+	   audio->rtcp.stat.tx.loss * 100.0 / (audio->rtcp.stat.tx.pkt + audio->rtcp.stat.tx.loss),
 	   audio->rtcp.stat.tx.dup, 
-	   audio->rtcp.stat.tx.dup * 100.0 / audio->rtcp.stat.tx.pkt,
+	   audio->rtcp.stat.tx.dup * 100.0 / (audio->rtcp.stat.tx.pkt + audio->rtcp.stat.tx.dup),
 	   audio->rtcp.stat.tx.reorder, 
-	   audio->rtcp.stat.tx.reorder * 100.0 / audio->rtcp.stat.tx.pkt,
+	   audio->rtcp.stat.tx.reorder * 100.0 / (audio->rtcp.stat.tx.pkt + audio->rtcp.stat.tx.reorder),
 	   "",
 	   audio->rtcp.stat.tx.loss_period.min / 1000.0, 
Index: /pjproject/trunk/pjsip-apps/src/samples/streamutil.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/streamutil.c	(revision 564)
+++ /pjproject/trunk/pjsip-apps/src/samples/streamutil.c	(revision 565)
@@ -605,9 +605,9 @@
 	   "",
 	   stat.rx.loss,
-	   stat.rx.loss * 100.0 / stat.rx.pkt,
+	   stat.rx.loss * 100.0 / (stat.rx.pkt + stat.rx.loss),
 	   stat.rx.dup, 
-	   stat.rx.dup * 100.0 / stat.rx.pkt,
+	   stat.rx.dup * 100.0 / (stat.rx.pkt + stat.rx.dup),
 	   stat.rx.reorder, 
-	   stat.rx.reorder * 100.0 / stat.rx.pkt,
+	   stat.rx.reorder * 100.0 / (stat.rx.pkt + stat.rx.reorder),
 	   "",
 	   stat.rx.loss_period.min / 1000.0, 
@@ -648,9 +648,9 @@
 	   "",
 	   stat.tx.loss,
-	   stat.tx.loss * 100.0 / stat.tx.pkt,
+	   stat.tx.loss * 100.0 / (stat.tx.pkt + stat.tx.loss),
 	   stat.tx.dup, 
-	   stat.tx.dup * 100.0 / stat.tx.pkt,
+	   stat.tx.dup * 100.0 / (stat.tx.pkt + stat.tx.dup),
 	   stat.tx.reorder, 
-	   stat.tx.reorder * 100.0 / stat.tx.pkt,
+	   stat.tx.reorder * 100.0 / (stat.tx.pkt + stat.tx.reorder),
 	   "",
 	   stat.tx.loss_period.min / 1000.0, 
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 564)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 565)
@@ -1303,9 +1303,9 @@
 	       indent,
 	       stat.rx.loss,
-	       stat.rx.loss * 100.0 / stat.rx.pkt,
+	       stat.rx.loss * 100.0 / (stat.rx.pkt + stat.rx.loss),
 	       stat.rx.dup, 
-	       stat.rx.dup * 100.0 / stat.rx.pkt,
+	       stat.rx.dup * 100.0 / (stat.rx.pkt + stat.rx.dup),
 	       stat.rx.reorder, 
-	       stat.rx.reorder * 100.0 / stat.rx.pkt,
+	       stat.rx.reorder * 100.0 / (stat.rx.pkt + stat.rx.reorder),
 	       indent, indent,
 	       stat.rx.loss_period.min / 1000.0, 
@@ -1362,9 +1362,9 @@
 	       indent,
 	       stat.tx.loss,
-	       stat.tx.loss * 100.0 / stat.tx.pkt,
+	       stat.tx.loss * 100.0 / (stat.tx.pkt + stat.tx.loss),
 	       stat.tx.dup, 
-	       stat.tx.dup * 100.0 / stat.tx.pkt,
+	       stat.tx.dup * 100.0 / (stat.tx.pkt + stat.tx.dup),
 	       stat.tx.reorder, 
-	       stat.tx.reorder * 100.0 / stat.tx.pkt,
+	       stat.tx.reorder * 100.0 / (stat.tx.pkt + stat.tx.reorder),
 
 	       indent, indent,